<?php
class Test extends Module 
{

	function Test() {
	}

	function runSiteTests() {
		global $SITE_LOCATION;
		require_once( $SITE_LOCATION . '/test/test.php');
		global $site;

		$results = array();

		foreach( $site[CSM_TESTS] as $testPath => $testPathClasses) {
			
			foreach( $testPathClasses as $testPathClass => $testMethods) {
				
				require_once( $SITE_LOCATION . '/test' . $testPath . '/' . $testPathClass . '.php');
				$testClass = new $testPathClass;
				foreach ( $testMethods as $testMethodName) {
					
					$pass = call_user_func( array($testClass, $testMethodName));
					
					$results[ $testPath][ $testPathClass] [$testMethodName] = $pass;
				}
			}
		}
		
		$this->printTextResults( $results);
		
	}

	function printTextResults( $results) {

		echo '<table border="1">';
			echo '<thead>';
				echo '<tr>';
					echo '<th>Path</th>';
					echo '<th>Test Class</th>';
					echo '<th>Test Method</th>';
					echo '<th>Pass?</th>';
				echo '</tr>';
			echo '</thead>';
			echo '<tbody>';
			foreach( $results as $testPath => $testPathClasses) {
				foreach( $testPathClasses as $testPathClass => $testMethods) {
					foreach( $testMethods as $testMethod => $pass) {
						echo '<tr>';
							echo '<td>' . $testPath . '</td>';
							echo '<td>' . $testPathClass . '</td>';
							echo '<td>' . $testMethod . '</td>';
							if( $pass) {
								echo '<td style="background-color:#00ff00">1</td>';								
							} else {
								echo '<td style="background-color:#ff0000">0</td>';
							}
						echo '</tr>';
					}
		       
				}
			}
			echo '</tbody>';
		echo '</table>';
	}

}
?>